/*******************************************************************************************
This file is part of iToday.

iToday is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

iToday is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with iContact.  If not, see <http://www.gnu.org/licenses/>.
* ------------------------------------------------------------------------------
*    iToday.cpp - Main of the iToday
* ------------------------------------------------------------------------------
*    Revision History
*    Date                  Author         Activity ID               Activity Headline
*    2009-10-13            Congqin				none						initial
*    2009-10-26            CubeWang				none						add Gesture
*******************************************************************************************/

#include "stdafx.h"

#define MAX_LOADSTRING 100


// ȫֱ:
HINSTANCE			g_hInst				= NULL;			// ǰʵ
HWND				g_hWndMenuBar		= NULL;		// ˵
PanelManager*		g_pPanelManager		= NULL;

// ˴ģаĺǰ:
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);


int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
    MSG msg;

    // ִӦóʼ:
    if (!InitInstance(hInstance, nCmdShow))
    {
        return FALSE;
    }

    HACCEL hAccelTable;
    hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_ITODAY));

    // Ϣѭ:
    while (GetMessage(&msg, NULL, 0, 0))
    {
        if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
    }

    delete g_pPanelManager ;

    return (int) msg.wParam;
}

//
//  : MyRegisterClass()
//
//  Ŀ: עᴰࡣ
//
//  ע:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
    WNDCLASS wc;

    wc.style         = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc   = WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDC_ITODAY));
    wc.hCursor       = 0;
    wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName  = 0;
    wc.lpszClassName = szWindowClass;

    return RegisterClass(&wc);
}

//
//   : InitInstance(HINSTANCE, int)
//
//   Ŀ: ʵ
//
//   ע:
//
//        ڴ˺Уȫֱбʵ
//        ʾ򴰿ڡ
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// ı
    TCHAR szWindowClass[MAX_LOADSTRING];	// 


    g_hInst = hInstance; // ʵ洢ȫֱ

    // Ӧóʼڼ䣬Ӧһ SHInitExtraControls Գʼ
    // 豸ضؼ磬CAPEDIT  SIPPREF
    SHInitExtraControls();

    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
    LoadString(hInstance, IDC_ITODAY, szWindowClass, MAX_LOADSTRING);

    //ѾУ򽫽ڴϣȻ˳
    hWnd = FindWindow(szWindowClass, szTitle);
    if (hWnd)
    {
        // ǰӴ
        // | 0x00000001ڽиǰ̨
        // Щڡ
        SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
        return 0;
    }

    if (!MyRegisterClass(hInstance, szWindowClass))
    {
        return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
                        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }

    // ʹ CW_USEDEFAULT ʱῼǲ˵ĸ߶(һ
    // ˵)ˣҪڴںС
    // ˵
    if (g_hWndMenuBar)
    {
        RECT rc;
        RECT rcMenuBar;

        GetWindowRect(hWnd, &rc);
        GetWindowRect(g_hWndMenuBar, &rcMenuBar);
        rc.bottom -= (rcMenuBar.bottom - rcMenuBar.top);

        MoveWindow(hWnd, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, FALSE);
    }

    g_pPanelManager = new PanelManager(hWnd, hInstance);

    if ( !g_pPanelManager->InitData() )
    {
        return FALSE;
    }

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    return TRUE;
}

//
//  : WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  Ŀ: ڵϢ
//
//  WM_COMMAND	- Ӧó˵
//  WM_PAINT	- 
//  WM_DESTROY	- ˳Ϣ
//
//

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{
    static SHACTIVATEINFO	s_sai;
    int						wmId, wmEvent;
    POINT					pt = { 0,0 } ;
    PAINTSTRUCT				ps;

    switch ( message )
    {
    case 0x0000C008
            /*0x0000C01D*/:
        ShowWindow(hWnd, SW_SHOW);
        SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
        break;

    case WM_MOUSEMOVE:
        break;

    case WM_LBUTTONDOWN:
        pt.x = LOWORD( lParam );
        pt.y = HIWORD( lParam );

        //g_pPanelManager-> RecordMouseDownPoint( pt );

        if ( ! g_pPanelManager-> ProcessMouseDownEvent( pt ) )
        {
            DebugPrintString(L"manage the clicked event is failure! " );
        }

        break;

    case WM_LBUTTONUP:
        pt.x = LOWORD( lParam );
        pt.y = HIWORD( lParam );

        if ( ! g_pPanelManager-> ProcessMouseUpEvent( pt ) )
        {
            DebugPrintString(L"manage the clicked event is failure! " );
        }

        break ;

    case WM_MISSEDEVENT:
        g_pPanelManager->m_HomePanel.CheckMissedEvent();
        break;

    case WM_TIMER:
        switch (wParam)
        {
        case HOME_TIME_TIMER_ID:
            if ( Home == g_pPanelManager->m_ActivedPanel )
            {
                g_pPanelManager->m_HomePanel.DrawTime();
            }
            break;
        case GESTURE_ANIMATION_TIMER_ID:
            g_pPanelManager->GetClickedPanelPoint()->ProcessAnimationTimer();
            break;
        default:
            break;
        }
        break;

    case WM_COMMAND:
        wmId    = LOWORD( wParam );
        wmEvent = HIWORD( wParam );
        // ˵ѡ:
        switch ( wmId )
        {
        case IDM_LOCK:
            SendMessage (hWnd, WM_CLOSE, 0, 0 );
            break;

        default:
            return DefWindowProc( hWnd, message, wParam, lParam );
        }
        break;

    case WM_CREATE:
        SHMENUBARINFO mbi;

        memset(&mbi, 0, sizeof(SHMENUBARINFO));
        mbi.cbSize		= sizeof(SHMENUBARINFO);
        mbi.hwndParent	= hWnd;
        mbi.dwFlags		= SHCMBF_HMENU | SHCMBF_HIDESIPBUTTON;
        mbi.nToolBarId	= IDR_MENU;
        mbi.hInstRes	= g_hInst;

        if (!SHCreateMenuBar(&mbi))
        {
            g_hWndMenuBar = NULL;
        }
        else
        {
            g_hWndMenuBar = mbi.hwndMB;
        }

        // ʼǳ򼤻Ϣṹ
        memset(&s_sai, 0, sizeof (s_sai));
        s_sai.cbSize = sizeof (s_sai);

        break;

    case WM_PAINT:
    {
        HDC hdc = BeginPaint(hWnd,&ps);

        g_pPanelManager->Draw();

        EndPaint(hWnd,&ps);
    }
    break;

    case WM_ERASEBKGND:
        break;

    case WM_GESTURE:
        if ( !g_pPanelManager->ProcessGesture(hWnd, message, wParam, lParam) )
        {
            DebugPrintString(L"MainThread: g_pPanelManager->ProcessGesture failed.\n");
        }
        break;

    case WM_DESTROY:
        KillTimer( hWnd, HOME_TIME_TIMER_ID) ;
        CommandBar_Destroy( g_hWndMenuBar );
        PostQuitMessage( 0 );
        break;

    case WM_ACTIVATE:
        // ǳ֪ͨǵļϢ
        SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
        break;

    case WM_SETTINGCHANGE:
        SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
        break;

    default:
        return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}





